import {Component, NgModule} from '@angular/core';
import {IgGridComponent} from "../../src/igniteui.angular2";
import {FormsModule} from '@angular/forms';
import {Northwind} from "./../data/northwind";
import {BrowserModule} from '@angular/platform-browser';
import {platformBrowserDynamic}    from '@angular/platform-browser-dynamic';


declare var jQuery: any;
@Component({
    selector: 'my-app',
    templateUrl: "./igGridTemplate.html"
})
export class AppComponent {
    private gridOptions: IgGrid;
    private id: string;
    private data: any;
    private newProduct: any;
    //private deleteRecord: any;

    constructor() {
        this.data = Northwind.getData();

        this.id = 'grid1';
        this.newProduct = this.createNewProduct();

        this.gridOptions = {
            autoCommit: true,
            width: "100%",
            height: "400px",
            autoGenerateColumns: false,
            columns: [
                {key: "ProductID", headerText: "Product ID", width: "50px", dataType: "number"},
                {key: "ProductName", headerText: "Name", width: "250px", dataType: "string"},
                {key: "QuantityPerUnit", headerText: "Quantity per unit", width: "250px", dataType: "string"},
                {
                    key: "UnitPrice",
                    headerText: "Unit Price",
                    width: "100px",
                    dataType: "number",
                    template: jQuery("#colTmpl").html()
                },
                {key: "Published", headerText: "Published", width: "100px", dataType: "bool", hidden: true},
                {
                    key: "Actions", headerText: "", width: "100px", dataType: "string", unbound: true,
                    template: "{{if ${Published} }}" +
                    "<input type='button' onclick='$(&#39;#locationsUnpublish&#39;).val(${ProductID});$(&#39;#locationsUnpublish&#39;).click()' value='Unpublish'/>" +
                    "{{else}}" +
                    "<input type='button' onclick='$(&#39;#locationsPublish&#39;).val(${ProductID});$(&#39;#locationsPublish&#39;).click()' value='Publish'/>" +
                    "{{/if}}"
                }
            ],
            primaryKey: "ProductID",
            features: [
                {
                    name: "Paging"
                },
                {
                    name: "Filtering"
                },
                {
                    name: "Sorting"
                }
            ]
        };
    }

    addLotsOfProducts() {
        let products = [];
        for (let _i = 1; _i < 5000; _i++) {
            let newProduct = {};
            newProduct["ProductID"] = this.data.length + _i;
            newProduct["ProductName"] = "product " + _i;
            newProduct["QuantityPerUnit"] = "4 kg pkg.";
            newProduct["UnitPrice"] = 34;
            newProduct["Published"] = _i%2;
            products.push(newProduct);
        }

        this.data = products;
    }

    public onPublish(productID: number) {
        let matchingProduct = this.data.filter(x => x.ProductID == productID)[0];
        matchingProduct.Published = true;
    }

    public onUnpublish(productID: number) {
        let matchingProduct = this.data.filter(x => x.ProductID == productID)[0];
        matchingProduct.Published = false;
    }

    createNewProduct() {
        var newProduct = {};
        newProduct["ProductID"] = this.data.length + 1;
        newProduct["ProductName"] = null;
        newProduct["QuantityPerUnit"] = null;
        newProduct["UnitPrice"] = null;
        return newProduct;
    }

    addRecord() {
        this.data.push(this.newProduct);
        this.newProduct = this.createNewProduct();
    };

    deleteRecord(val) {
        var ind = 0;
        this.data.filter(function (item, index) {
            if (item["ProductID"] === val) {
                ind = index
            }
            ;
            return item["ProductID"] === val;
        });
        this.data.splice(ind, 1);
    };
}

@NgModule({
    imports: [BrowserModule, FormsModule],
    declarations: [AppComponent, IgGridComponent],
    bootstrap: [AppComponent]
})
export class AppModule {
}

platformBrowserDynamic().bootstrapModule(AppModule);